﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using System.Security;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace RegMarkLib
{
    public class MarkChecker
    {
        static public bool CheckMark(string mark)
        {
            mark = mark.ToLower().Trim();

            Regex markReg = new Regex("^[ABEKMHOPCTY]{1}\\d{3}[ABEKMHOPCTYX]{2}(\\d{3}|\\d{2})$");
            
            /// #ToDo
            /// Сделать валидацию по коду региона

            if (markReg.IsMatch(mark))
            {                
                return true;
            } else
                return false;
        }

        static public string GetNextMarkAfter(string mark)
        {
            mark.ToUpper();
            CheckMark(mark);
            char letter1 = mark[0];
            int numberPart1 = int.Parse(mark.Substring(1, 3));
            string letters = mark.Substring(4, 2);
            int numberPart2;
            if (mark.Length == 9)
                numberPart2 = int.Parse(mark.Substring(6, 3));
            else
                numberPart2 = int.Parse(mark.Substring(6, 2));

            letters = IncrementLetters(letters);
            if (letters == "AAA") 
            {
                numberPart1++;
                letters = "AA";
                if (numberPart1 > 999)
                {
                    numberPart1 = 0;
                    letter1 = IncrementLetter(letter1);
                }
            }
            return $"{letter1}{numberPart1:D3}{letters}{numberPart2:D3}";
        }

        private static char IncrementLetter(char letter)
        {
            if (letter == 'Z')
            {
                return 'A';
            }
            return (char)(letter + 1);
        }

        private static string IncrementLetters(string letters)
        {
            char[] chars = letters.ToCharArray();
            for (int i = chars.Length - 1; i >= 0; i--)
            {
                if (chars[i] == 'Z')
                {
                    chars[i] = 'A';
                }
                else
                {
                    chars[i]++;
                    return new string(chars);
                }
            }
            return new string(chars);
        }
        public static string GetNextMarkAfterInRange(string prevMark, string rangeStart, string rangeEnd)
        {
            prevMark.ToUpper();
            CheckMark(prevMark);
            
            char letter1 = prevMark[0];
            char letter2 = prevMark[4];
            char letter3 = prevMark[5];
            Dictionary<char, int> map = new Dictionary<char, int>();
            map.Add('A', 0);
            map.Add('B', 1);
            map.Add('E', 2);
            map.Add('K', 3);
            map.Add('M', 4);
            map.Add('H', 5);
            map.Add('O', 6);
            map.Add('P', 7);
            map.Add('C', 8);
            map.Add('T', 9);
            map.Add('Y', 10);
            map.Add('X', 11);

            int letterNum = map[letter1] * 120 + map[letter2] * 12 + map[letter3];
            // Максимум: 1463
            // AAA - 0
            // AAB - 1
            // AAX - 11
            // ABA - 12
            // XXX - 1463

            // 12 // 120 - 0
            // 12 // 12 - 1
            // 12 // 1 - 0

            int regNumber = int.Parse(prevMark.Substring(1, 3));
            string regionNum = 

            // Увеличиваем буквенный номер
            if (letterNum == 1463)
            {
                letterNum = 0;
                regNumber++;
            } else
            {
                letterNum++;
            }

            // Если здесь regNumber превышает максимальный, вернуть out of stock

            int first = letterNum / 120;
            int second = (letterNum - first * 120) / 12;
            int third = letterNum - first * 120 - second * 12;

            // Преобразовываем обратно в буквы
            char firstOut   = map.FirstOrDefault(x => x.Value == first).Key;
            char secondOut  = map.FirstOrDefault(x => x.Value == second).Key;
            char thirdOut   = map.FirstOrDefault(x => x.Value == third).Key;

            // Регистрационный номер преобразовываем в число
            int regNumberFirst = regNumber / 100;
            int regNumberSecond = (regNumber / 10) % 10;
            int regNumberThird = regNumber % 10;

            return regNumberFirst.ToString() + firstOut + secondOut + thirdOut + regNumberSecond.ToString() + regNumberThird.ToString() + ;
        }

        static public int GetCombinationsCountInRange(string mark1, string mark2)
        {
            throw new NotImplementedException();
        }
    }
}
